# -*- coding: utf-8 -*-
# Generated by Django 1.11.6 on 2020-02-18 23:29
from __future__ import unicode_literals

from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [("customers", "0010_auto_20200618_1509")]

    sql = """
    CREATE VIEW customers_financialrecordservice AS SELECT 'I'::text || customers_invoice.id::text AS record_id, customers_invoice.paid, customers_invoice.due_date AS ts, CASE WHEN customers_invoice.kind <> 3 THEN customers_invoice.total ELSE NULL::integer END AS charge, CASE WHEN customers_invoice.kind = 3 THEN customers_invoice.total ELSE NULL::integer END AS credit, customers_invoice.comment, customers_invoice.customer_id, customers_invoice_service.service_id FROM customers_invoice, customers_invoice_service WHERE customers_invoice_service.invoice_id = customers_invoice.id GROUP BY customers_invoice.id, customers_invoice_service.id UNION SELECT 'P'::text || customers_payment.id::text AS record_id, true AS paid, customers_payment.paid_on AS ts, NULL::integer AS charge, customers_payment.amount AS credit, customers_payment.comment, customers_payment.customer_id, customers_payment_service.service_id FROM customers_payment,     customers_payment_service WHERE customers_payment_service.payment_id = customers_payment.id GROUP BY customers_payment.id, customers_payment_service.id ORDER BY 3 DESC
    """

    balance_sql = """
    CREATE VIEW  customers_balanceservice AS SELECT fr.customer_id AS id, fr.customer_id, COALESCE(sum(fr.credit), 0::bigint) - COALESCE(sum(fr.charge), 0::bigint) AS balance, fr.service_id FROM customers_financialrecordservice fr GROUP BY fr.customer_id, fr.service_id
    """
    operations = [
        migrations.RunSQL("DROP VIEW IF EXISTS customers_balanceservice"),
        migrations.RunSQL("DROP VIEW IF EXISTS customers_financialrecordservice"),
        migrations.RunSQL(sql),
        migrations.RunSQL(balance_sql),
    ]
